/* Copyright 2020 NXP
 *
 * SPDX-License-Identifier: Apache-2.0
 */

/** @file se05x_Personalization_del.c
 *
 * This file solves purpose for
 */

/* ************************************************************************** */
/* Includes                                                                   */
/* ************************************************************************** */

#include "se05x_Perso_Delete_Mod_RSAKeyGen.h"
#include "se05x_perso_api.h"
#include "nxEnsure.h"
#include "nxLog_hostLib.h"

/* ************************************************************************** */
/* Local Defines                                                              */
/* ************************************************************************** */
/* ************************************************************************** */
/* Structures and Typedefs                                                    */
/* ************************************************************************** */

/* ************************************************************************** */
/* Global Variables                                                           */
/* ************************************************************************** */

/* ************************************************************************** */
/* Static function declarations                                               */
/* ************************************************************************** */

/* ************************************************************************** */
/* Public Functions                                                           */
/* ************************************************************************** */

smStatus_t ex_perso_RM_MOD_RSAKEYGEN(pSe05xSession_t session_ctx)
{
    smStatus_t status;
    const uint8_t rm_mod[] = SE05X_API_PERSO_MOD_RSAKEYGEN;

    status = Se05x_API_Perso_Set_DELETE_OS_MODULE(session_ctx, rm_mod, sizeof(rm_mod));
    ENSURE_OR_GO_CLEANUP(status == SM_OK);
cleanup:
    return status;
}
/* ************************************************************************** */
/* Private Functions                                                          */
/* ************************************************************************** */
